struct Solution;

// 思路双指针
impl Solution {
    pub fn count_and_say(n: i32) -> String {
        if n == 1 {
            return "1".to_string();
        }

        let pre = Self::count_and_say(n - 1);

        let mut left = 0;
        let mut right = left + 1;
        let mut pre_char = pre.chars().nth(left);

        let mut res = String::new();

        while right < pre.len() {
            if pre.chars().nth(right) != pre_char {
                res.push_str((right - left).to_string().as_str());
                res.push(pre_char.unwrap());
                left = right;
                pre_char = pre.chars().nth(left);
            }
            right += 1;
        }

        res.push_str((right - left).to_string().as_str());
        res.push(pre_char.unwrap());

        res
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_count_and_say() {
        assert_eq!(Solution::count_and_say(1), String::from("1"));
        assert_eq!(Solution::count_and_say(2), String::from("11"));
        assert_eq!(Solution::count_and_say(3), String::from("21"));
        assert_eq!(Solution::count_and_say(4), String::from("1211"));
        assert_eq!(Solution::count_and_say(5), String::from("111221"));
        assert_eq!(Solution::count_and_say(6), String::from("312211"));
    }
}
