struct Solution;
impl Solution {
    pub fn search_range(nums: Vec<i32>, target: i32) -> Vec<i32> {
        return Self::helper(&nums, 0, nums.len() as i32 - 1, target);
    }

    fn helper(nums: &Vec<i32>, left: i32, right: i32, target: i32) -> Vec<i32> {
        if left > right {
            return vec![-1, -1];
        }
        if left == right {
            if nums[left as usize] == target {
                return vec![left, right];
            } else {
                return vec![-1, -1];
            }
        }

        let mid = left + (right - left + 1) / 2;
        if nums[mid as usize] == target {
            let left_res = Self::helper(nums, left, mid - 1, target);
            let right_res = Self::helper(nums, mid + 1, right, target);
            let l = if left_res != vec![-1, -1] {
                left_res[0]
            } else {
                mid
            };

            let r = if right_res != vec![-1, -1] {
                right_res[1]
            } else {
                mid
            };
            return vec![l, r];
        } else if nums[mid as usize] < target {
            return Self::helper(nums, mid + 1, right, target);
        } else {
            return Self::helper(nums, left, mid - 1, target);
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_search_range() {
        assert_eq!(
            Solution::search_range(vec![5, 7, 7, 8, 8, 10], 8),
            vec![3, 4]
        );
        assert_eq!(
            Solution::search_range(vec![5, 7, 7, 8, 8, 10], 6),
            vec![-1, -1]
        );
    }
}
