struct Solution;

impl Solution {
    pub fn generate_parenthesis(n: i32) -> Vec<String> {
        let mut res = vec![];
        let mut cur = String::new();
        cur.push_str("(");
        let left = n;

        Self::helper(n, left, &mut cur, &mut res);

        res
    }

    fn helper(n: i32, left: i32, cur: &mut String, res: &mut Vec<String>) {
        let mut left = left;
        if (2 * n - cur.len() as i32) < left {
            return;
        }
        if left == 0 && (cur.len() as i32 == 2 * n) {
            res.push(cur.to_string());
        }

        for s in vec!["(", ")"] {
            if cur.len() as i32 - 2 * (n - left) == 0 && s == ")" {
                continue;
            }
            if s == ")" {
                left -= 1;
                cur.push_str(s);
                Self::helper(n, left, cur, res);
            } else {
                cur.push_str(s);
                Self::helper(n, left, cur, res);
            }

            cur.pop();
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_generate_parenthesis() {
        assert_eq!(
            Solution::generate_parenthesis(3),
            vec![
                String::from("((()))"),
                String::from("(()())"),
                String::from("(())()"),
                String::from("()(())"),
                String::from("()()()"),
            ]
        );
    }

    #[test]
    fn test_generate_parenthesis2() {
        assert_eq!(
            Solution::generate_parenthesis(2),
            vec![String::from("(())"), String::from("()()"),]
        );
    }
}
