struct Solution;

impl Solution {
    pub fn total_n_queens(n: i32) -> i32 {
        let mut col_mask = vec![false; n as usize];
        let mut diagonal_mask: Vec<(usize, usize)> = vec![];

        Self::helper(0, n as usize, &mut col_mask, &mut diagonal_mask)
    }

    fn helper(
        cur_row: usize,
        n: usize,
        col_mask: &mut Vec<bool>,
        diagonal_mask: &mut Vec<(usize, usize)>,
    ) -> i32 {
        let mut count = 0;
        if cur_row == n {
            return 1;
        }

        for c in 0..n {
            if col_mask[c] {
                continue;
            }
            let mut flag = false;
            for pair in diagonal_mask.iter() {
                let row_diff = cur_row.abs_diff(pair.0);
                let col_diff = c.abs_diff(pair.1);
                if row_diff == col_diff {
                    flag = true;
                    break;
                }
            }
            if flag {
                continue;
            }
            col_mask[c] = true;
            diagonal_mask.push((cur_row, c));
            let ans = Self::helper(cur_row + 1, n, col_mask, diagonal_mask);
            count += ans;

            col_mask[c] = false;
            diagonal_mask.pop();
        }

        count
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_total_n_queens() {
        let n = 4;
        let res = Solution::total_n_queens(n);
        assert_eq!(res, 2);
    }
}
