struct Solution;

impl Solution {
    pub fn get_permutation(n: i32, k: i32) -> String {
        let n = n as usize;
        let mut v = vec![0; n];
        for i in 0..n {
            v[i] = (i + 1) as u8;
        }
        let mut count = 0;
        let mut cur = vec![];
        Self::dfs(&mut count, 0, n, k, &mut v, &mut cur)
    }

    fn dfs(
        count: &mut i32,
        idx: usize,
        n: usize,
        k: i32,
        v: &mut Vec<u8>,
        cur: &mut Vec<u8>,
    ) -> String {
        if idx == n {
            let s = cur
                .iter()
                .map(|i| ((*i) + b'0') as char)
                .collect::<String>();
            *count += 1;
            // println!("k: {}, count: {}, s: {}", k, *count, s);
            if *count == k {
                return s;
            } else {
                return "".to_string();
            }
        }

        for i in idx..n {
            let mut tmp = v[i];
            cur.push(v[i]);

            for j in ((idx + 1)..=i).rev() {
                v[j] = v[j - 1];
            }
            v[idx] = tmp;
            // println!("v: {:?}, i: {}, idx: {}", v, i, idx);

            let s = Self::dfs(count, idx + 1, n, k, v, cur);
            if s != "" {
                return s;
            }
            cur.pop();
            tmp = v[idx];
            for j in idx..i {
                v[j] = v[j + 1];
            }
            v[i] = tmp;
        }

        "".to_string()
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case1() {
        let (n, k) = (3, 5);
        let res = Solution::get_permutation(n, k);
        assert_eq!(res, "312");
    }

    #[test]
    fn test_case2() {
        let (n, k) = (4, 9);
        let res = Solution::get_permutation(n, k);
        assert_eq!(res, "2314");
    }
}
