struct Solution;

impl Solution {
    pub fn restore_ip_addresses(s: String) -> Vec<String> {
        let mut res = vec![];
        let mut cur = vec![];
        let nums = s.chars().map(|x| x.to_digit(10).unwrap()).collect::<Vec<u32>>();
        Solution::helper(&nums, &mut cur, 0, nums.len(), &mut res);
        res
    }

    fn helper(nums: &Vec<u32>, cur: &mut Vec<u32>, idx: usize, n: usize, res: &mut Vec<String>) {
        if n  == idx {
            if cur.len() == 4  {
                let s: Vec<String> = cur.into_iter().map(|x| x.to_string()).collect();
                let s = s.join(".");
                res.push(s);
                return
            } else {
                return
            }

        }

        let mut candidates = vec![];
        let mut i = idx;
        while i < n {
            if i == idx + 3 { break; }
            if nums[i] == 0 && i == idx {
                candidates.push((nums[i], i+1));
                break;
            }
            if i == idx {
                candidates.push((nums[i], i+1));
            }
            if i == idx + 1 {
                candidates.push((10*nums[i-1] + nums[i], i+1));
            }
            if i == idx + 2 {
                let c = 100*nums[i-2] + 10* nums[i-1] + nums[i];
                if c <= 255 {
                    candidates.push((c, i+1));
                }
            }
            i += 1;
        }

        for (d, next_idx) in candidates {
            cur.push(d);
            Solution::helper(nums, cur, next_idx, n, res);
            cur.pop();
        }

    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_restore_ip_addresses() {
        let s = String::from("101023");
        let res = Solution::restore_ip_addresses(s);
        assert_eq!(res, vec!["1.0.10.23", "1.0.102.3",  "10.1.0.23", "10.10.2.3", "101.0.2.3"])
    }
}