struct Solution;

// dp[i] = min[dp[i+1], dp[i+1 + nums[i])
// if nums[i] == 0 skip dp[i]

impl Solution {
    pub fn jump(nums: Vec<i32>) -> i32 {
        let n = nums.len();
        if n == 1 {
            return 1;
        }
        let mut dp = vec![0; n];
        for i in (0..n - 1).rev() {
            if nums[i] == 0 {
                dp[i] = i32::MAX - 1;
            }
            let start = i + 1;
            let end = n.min(start + nums[i] as usize);
            let mut value = i32::MAX - 1;
            for j in start..end {
                value = value.min(dp[j] + 1);
            }
            dp[i] = if value == i32::MAX {
                i32::MAX - 1
            } else {
                value
            };
        }

        dp[0]
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case1() {
        let nums = vec![2, 3, 0, 1, 4];
        let res = Solution::jump(nums);
        assert_eq!(res, 2);
    }

    #[test]
    fn test_case2() {
        let nums = vec![2, 0, 2, 0, 1];
        let res = Solution::jump(nums);
        assert_eq!(res, 2);
    }

    #[test]
    fn test_case3() {
        let nums = vec![5, 9, 3, 2, 1, 0, 2, 3, 3, 1, 0, 0];
        let res = Solution::jump(nums);
        assert_eq!(res, 3);
    }
}
