struct Solution;

impl Solution {
    pub fn trap(height: Vec<i32>) -> i32 {
        // max_l[i] = max(max_l[i-1], h[i])
        // max_r[i] = max(max_r[i+1], h[i])
        let n = height.len();
        let mut max_l = vec![0; n];
        let mut max_r = vec![0; n];
        for i in 0..n {
            max_l[i] = if i == 0 {
                height[i]
            } else {
                max_l[i - 1].max(height[i])
            }
        }
        for i in (0..n).rev() {
            max_r[i] = if i == n - 1 {
                height[i]
            } else {
                max_r[i + 1].max(height[i])
            }
        }
        let mut sum = 0;
        for i in 0..n {
            sum += 0.max(max_l[i].min(max_r[i]) - height[i])
        }
        sum
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_trap() {
        assert_eq!(Solution::trap(vec![0, 1, 0, 2, 1, 0, 1, 3, 2, 1, 2, 1]), 6);
    }
}
