struct Solution;

impl Solution {
    pub fn letter_combinations(digits: String) -> Vec<String> {
        let mut res = vec![];
        let l = digits.len();

        if l == 0 { return res; }
        if l == 1 { return Solution::get_str(digits.as_str()); }
        if l == 2 {
            let (s1, s2) = digits.split_at(1);
            let v1 = Solution::get_str(s1);
            let v2 = Solution::get_str(s2);
            for s1 in v1.iter() {
                for s2 in v2.iter() {
                    res.push(format!("{}{}", s1, s2));
                }
            }
            return res;
        }
        let (s1, s2) = digits.split_at(1);
        let v1 = Solution::get_str(s1);
        let v2 = Solution::letter_combinations(s2.to_string());
        for s1 in v1.iter() {
            for s2 in v2.iter() {
                res.push(format!("{}{}", s1, s2));
            }
        }

        res

    }

    fn get_str(digits: &str) -> Vec<String> {
        match digits {
            "2" => {
                vec!["a".to_string(), "b".to_string(), "c".to_string()]
            },
            "3" => {
                vec!["d".to_string(), "e".to_string(), "f".to_string()]
            },
            "4" => {
                vec!["g".to_string(), "h".to_string(), "i".to_string()]
            },
            "5" => {
                vec!["j".to_string(), "k".to_string(), "l".to_string()]
            },
            "6" => {
                vec!["m".to_string(), "n".to_string(), "o".to_string()]
            },
            "7" => {
                vec!["p".to_string(), "q".to_string(), "r".to_string(), "s".to_string()]
            },
            "8" => {
                vec!["t".to_string(), "u".to_string(), "v".to_string()]
            },
            "9" => {
                vec!["w".to_string(), "x".to_string(), "y".to_string(), "z".to_string()]
            },
            _ => vec![]
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let digits = "23".to_string();
        let res = Solution::letter_combinations(digits);
        let expect = vec![
            "ad",
            "ae",
            "af",
            "bd",
            "be",
            "bf",
            "cd",
            "ce",
            "cf",
        ];
        assert_eq!(res, expect)
    }

    #[test]
    fn test_case_2() {
        let digits = "".to_string();
        let res = Solution::letter_combinations(digits);
        let expect: Vec<String> = vec![];
        assert_eq!(res, expect)
    }

}