use crate::solutions::ListNode;

struct Solution;

impl Solution {
    pub fn reverse_k_group(head: Option<Box<ListNode>>, k: i32) -> Option<Box<ListNode>> {
        if head.is_none() {
            return None;
        }
        let mut dummy = Box::new(ListNode {
            val: -1,
            next: head,
        });
        let mut right = &mut dummy.clone();

        let mut left = &mut dummy;

        let k = k as usize;
        let mut v = Vec::with_capacity(k);
        for _ in 0..k {
            v.push(0);
        }
        let mut i: usize = 0;
        while right.next.is_some() && i < k {
            right = right.next.as_mut().unwrap();
            v[i] = right.val;
            i += 1;

            if i == k {
                for j in (0..k).rev() {
                    left = left.next.as_mut().unwrap();
                    // println!("j: {}, v[j]: {}, val: {}", j, v[j], left.val);

                    left.val = v[j]
                }
                i = 0;
            }
        }

        // println!("{:?}", to_vec(dummy.next.clone()));

        dummy.next
    }

    pub fn reverse_k_group2(head: Option<Box<ListNode>>, k: i32) -> Option<Box<ListNode>> {
        let mut dummy_head = Some(Box::new(ListNode { val: 0, next: head }));
        let mut head = dummy_head.as_mut();
        'outer: loop {
            let mut start = head.as_mut().unwrap().next.take();
            if start.is_none() {
                break 'outer;
            }
            let mut end = start.as_mut();
            for _ in 0..(k - 1) {
                end = end.unwrap().next.as_mut();
                if end.is_none() {
                    head.as_mut().unwrap().next = start;
                    break 'outer;
                }
            }
            let tail = end.as_mut().unwrap().next.take();
            // BEFORE: head -> start -> 123456... -> end   -> tail
            // AFTER:  head -> end   -> ...654321 -> start -> tail
            let end = Solution::reverse(start, tail);
            head.as_mut().unwrap().next = end;
            for _ in 0..k {
                head = head.unwrap().next.as_mut()
            }
        }
        dummy_head.unwrap().next
    }

    #[inline(always)]
    fn reverse(head: Option<Box<ListNode>>, tail: Option<Box<ListNode>>) -> Option<Box<ListNode>> {
        let mut prev = tail;
        let mut current = head;
        while let Some(mut current_node_inner) = current {
            let next = current_node_inner.next.take();
            current_node_inner.next = prev.take();
            prev = Some(current_node_inner);
            current = next;
        }
        prev
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{to_list, to_vec};

    #[test]
    fn test_reverse_k_group() {
        let l = to_list(vec![1, 2, 3, 4, 5, 6, 7, 8, 9, 10]);
        let l = Solution::reverse_k_group(l, 3);
        let v = to_vec(l);
        assert_eq!(v, vec![3, 2, 1, 6, 5, 4, 9, 8, 7, 10]);
    }

    #[test]
    fn test_reverse_k_group_2() {
        let l = to_list(vec![1, 2, 3, 4, 5, 6, 7, 8, 9, 10]);
        let l = Solution::reverse_k_group2(l, 5);
        let v = to_vec(l);
        assert_eq!(v, vec![5, 4, 3, 2, 1, 10, 9, 8, 7, 6]);
    }
}
