struct Solution;
impl Solution {
    pub fn group_anagrams(strs: Vec<String>) -> Vec<Vec<String>> {
        let mut res: Vec<Vec<String>> = vec![];
        let mut cur_idx = 0;

        let mut m = std::collections::HashMap::<[u8; 26], usize>::new();

        for s in strs {
            let mut v = [0; 26];
            for c in s.chars() {
                let n = c as usize - 'a' as usize;
                v[n] += 1;
            }

            match m.get(&v) {
                Some(i) => {
                    res[*i].push(s);
                }
                None => {
                    m.insert(v, cur_idx);
                    if res.len() < cur_idx + 1 {
                        res.push(vec![]);
                    }
                    res[cur_idx].push(s);
                    cur_idx += 1;
                }
            }
        }

        res
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_group_anagram() {
        let strs = vec![
            "eat".to_string(),
            "tea".to_string(),
            "tan".to_string(),
            "ate".to_string(),
            "nat".to_string(),
            "bat".to_string(),
        ];
        let res = Solution::group_anagrams(strs);
        let expect = vec![vec!["eat", "tea", "ate"], vec!["tan", "nat"], vec!["bat"]];
        assert_eq!(res, expect);
    }
}
