struct Solution;

use std::collections::HashMap;

impl Solution {

    pub fn is_interleave(s1: String, s2: String, s3: String) -> bool {
        let (m, n, p) = (s1.len(), s2.len(), s3.len());
        if m + n != p { return false; }
        let mut dp = vec![vec![false; n+1]; m+1];
        dp[0][0] = true;
        for i in 1..=m {
            dp[i][0] = s1[..i] == s3[..i];
        }
        for j in 1..=n {
            dp[0][j] = s2[..j] == s3[..j];
        }

        for i in 1..=m {
            for j in 1..=n {
                dp[i][j] = (dp[i-1][j] && s1.chars().nth(i-1) == s3.chars().nth(i+j-1))
                    || (dp[i][j-1] && s2.chars().nth(j-1) == s3.chars().nth(i+j-1));
            }
        }

        dp[m][n]

    }

    pub fn is_interleave1(s1: String, s2: String, s3: String) -> bool {
        let mut res: HashMap<(usize, usize, usize), bool> = HashMap::new();
        let r = Solution::helper(&s1[..], &s2[..], &s3[..], (0, 0, 0), (s1.len(), s2.len(), s3.len()), &mut res);
        r
    }

    fn helper(s1: &str, s2: &str, s3: &str, idx: (usize, usize, usize), len: (usize, usize, usize),  res: &mut HashMap<(usize, usize, usize), bool>) -> bool {

        let (i, j, k) = idx;
        let (m, n , p) = len;
        if let Some(&v) = res.get(&(i,j,k)) {
            return v;
        }
        if i == m {
            return &s2[j..] == &s3[k..];
        }

        if j == n {
            return &s1[i..] == &s3[k..];
        }

        if m + n != p {
            return false;
        }

        if s1.chars().nth(i) == s3.chars().nth(k) {
            let r = Solution::helper(&s1[..], &s2[..], &s3[..], (i+1, j, k+1), (m, n, p), res);

            if r {
                res.insert((i,j,k), r);
                return r;
            }

        }

        if s2.chars().nth(j) == s3.chars().nth(k) {
            let r = Solution::helper(&s1[..], &s2[..], &s3[..], (i, j+1, k+1), (m, n, p), res);

            if r {
                res.insert((i,j,k), r);
                return r;
            }
        }

        res.insert((i,j,k), false);
        false



    }

    // TLE
    // fn helper1(s1: &str, s2: &str, s3: &str) -> bool {
    //     if s1 == "" {
    //         return s2 == s3;
    //     }
    //     if s2 == "" {
    //         return s1 == s3;
    //     }
    //     if s1.len() + s2.len() != s3.len() {
    //         return false;
    //     }
    //
    //
    //     return (s1.chars().nth(0) == s3.chars().nth(0) && Solution::helper1(&s1[1..], &s2[..], &s3[1..])) ||
    //         (s2.chars().nth(0) == s3.chars().nth(0) && Solution::helper1(&s1[..], &s2[1..], &s3[1..]));
    //
    // }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_is_interleave1() {
        let s1 = String::from("aabcc");
        let s2 = String::from("dbbca");
        let s3 = String::from("aadbbcbcac");
        let res = Solution::is_interleave1(s1,s2, s3);
        assert_eq!(res, true);
    }
    #[test]
    fn test_is_interleave2() {
        let s1 = String::from("aabcc");
        let s2 = String::from("dbbca");
        let s3 = String::from("aadbbcbcac");
        let res = Solution::is_interleave(s1,s2, s3);
        assert_eq!(res, true);
    }
}