struct Solution;

impl Solution {
    pub fn largest_rectangle_area(heights: Vec<i32>) -> i32 {
        let mut max_area = 0;
        let l = heights.len();
        if l == 0 { return 0; }
        if l == 1 { return heights[0]; }
        let mut v = vec![0; l + 2];
        for i in 0..l {
            v[i+1] = heights[i];
        }

        let heights = v;
        let mut stack = std::collections::VecDeque::new();
        for i in 0..heights.len() {
            while !stack.is_empty() && heights[*stack.back().unwrap()] > heights[i] {
                let idx = stack.pop_back().unwrap();
                let height = heights[idx];
                let width = i as i32 -  *stack.back().unwrap() as i32 - 1;
                max_area = max_area.max(height * width);
            }
            stack.push_back(i);
        }

        max_area

    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_largest_rectangle_area() {
        let heights = vec![2,1,5,6,2,3];
        let res = Solution::largest_rectangle_area(heights);
        assert_eq!(res, 10);

    }
}