struct Solution;


impl Solution {
    pub fn my_atoi2(s: String) -> i32 {
        let mut res: i32 = 0;
        let mut sign: i32 = 1;
        let mut i: usize = 0;
        while i < s.len() && s.chars().nth(i).unwrap() == ' ' {
            i += 1;
        }
        if i < s.len() && (s.chars().nth(i).unwrap() == '+' || s.chars().nth(i).unwrap() == '-') {
            sign = if s.chars().nth(i).unwrap() == '+' {
                1
            } else {
                -1
            };
            i += 1;
        }

        while i < s.len() && s.chars().nth(i).unwrap().is_digit(10) {
            let digit = s.chars().nth(i).unwrap() as i32 - '0' as i32;
            if res > i32::MAX / 10 || (res == i32::MAX / 10 && digit > 7) {
                return if sign == 1 {
                    i32::MAX
                } else {
                    i32::MIN
                };
            }
            res = res * 10 + digit;
            i += 1;

        }


        res * sign

    }

    pub fn my_atoi(str: String) -> i32 {
        let (n, s) = match str.chars().skip_while(|x| x.is_whitespace()).take(1).next() {
            Some('+') => (1, 1),
            Some(x) if x.is_digit(10) => (0, 1),
            Some('-') => (1, -1),
            _ => return 0,
        };
        println!("n: {}, s: {}", n, s);
        let mut res = 0i32;
        let overflow = if s > 0 { std::i32::MAX } else { std::i32::MIN };
        for c in str.chars().skip_while(|x| x.is_whitespace()).skip(n)
            .take_while(|x| x.is_digit(10)) {
                let (r, o) = res.overflowing_mul(10);
                if o { return overflow; }
                let (r, o) = r.overflowing_add(s*(c as i32 - '0' as i32));
                if o { return overflow; }
                res = r;
        }
        res
    }
}


#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_my_atoi() {
        assert_eq!(Solution::my_atoi("42".to_string()), 42);
        assert_eq!(Solution::my_atoi("   -42".to_string()), -42);
        assert_eq!(Solution::my_atoi("4193 with words".to_string()), 4193);
        assert_eq!(Solution::my_atoi("words and 987".to_string()), 0);
        assert_eq!(Solution::my_atoi("-91283472332".to_string()), -2147483648);
        assert_eq!(Solution::my_atoi("+1".to_string()), 1);
        assert_eq!(Solution::my_atoi("+-2".to_string()), 0);
        assert_eq!(Solution::my_atoi("+".to_string()), 0);
        assert_eq!(Solution::my_atoi("".to_string()), 0);
        assert_eq!(Solution::my_atoi("-2147483648".to_string()), -2147483648);
        assert_eq!(Solution::my_atoi("-2147483649".to_string()), -2147483648);
        assert_eq!(Solution::my_atoi("-2147483648".to_string()), -2147483648);
        assert_eq!(Solution::my_atoi("-2147483649".to_string()), -2147483648);
        assert_eq!(Solution::my_atoi("-2147483648".to_string()), -2147483648);
        assert_eq!(Solution::my_atoi2("-2147483649".to_string()), -2147483648);
        assert_eq!(Solution::my_atoi2("-2147483648".to_string()), -2147483648);
    }
}