struct Solution;

impl Solution {
    pub fn str_str(haystack: String, needle: String) -> i32 {
        let (hlen, nlen) = (haystack.len(), needle.len());
        if nlen == 0 {
            return 0;
        } else if hlen < nlen {
            return -1;
        }

        for i in 0..=(hlen - nlen) {
            if haystack[i..i + nlen] == needle {
                return i as i32;
            }
        }

        -1
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_str_str() {
        assert_eq!(
            Solution::str_str(String::from("hello"), String::from("ll")),
            2
        );
        assert_eq!(
            Solution::str_str(String::from("aaaaa"), String::from("bba")),
            -1
        );
    }
}
