use super::ListNode;

struct Solution;

impl Solution {
    pub fn swap_pairs(head: Option<Box<ListNode>>) -> Option<Box<ListNode>> {
        if head.is_none() {
            return None;
        }
        let mut head = head;
        let mut cur = &mut head;

        while cur.is_some() && cur.as_mut().unwrap().next.is_some() {
            let cur_node = cur.as_mut().unwrap();
            let next_node = cur_node.next.as_mut().unwrap();
            let tmp = cur_node.val;
            cur_node.val = next_node.val;
            next_node.val = tmp;
            cur = &mut next_node.next;
        }

        head
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{to_list, to_vec};

    #[test]
    fn test_swap_pairs() {
        let l = to_list(vec![1, 2, 3, 4]);
        let l = Solution::swap_pairs(l);
        let v = to_vec(l);
        assert_eq!(v, vec![2, 1, 4, 3]);
    }
}
