struct Solution;
use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn is_balanced(root: Option<Rc<RefCell<TreeNode>>>) -> bool {

        let (res, _) = Solution::helper(root);
        res

    }

    fn helper(root: Option<Rc<RefCell<TreeNode>>>) -> (bool, i32) {
        if root.is_none() {
            return (true, 0);
        } else {
            let node = root.unwrap();
            let (lb, lh) = Solution::helper(node.borrow().left.clone());
            let (rb, rh) = Solution::helper(node.borrow().right.clone());
            let res_b = lb && rb && (lh-rh).abs() <= 1;
            let res_h = lh.max(rh) + 1;

            return (res_b, res_h);
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{vec_to_tree};

    #[test]
    fn test_is_balanced() {
        let nums = vec![Some(3),Some(9),Some(20),None,None,Some(15),Some(7)];
        let root = vec_to_tree(nums);
        let res = Solution::is_balanced(root);
        assert_eq!(res, true);
    }


    #[test]
    fn test_is_balanced2() {
        let nums = vec! [Some(1),Some(2),Some(2),Some(3),Some(3),None,None,Some(4),Some(4)];
        let root = vec_to_tree(nums);
        let res = Solution::is_balanced(root);
        assert_eq!(res, false);
    }
}