struct Solution;

use crate::solutions::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;

impl Solution {
    pub fn level_order_bottom(root: Option<Rc<RefCell<TreeNode>>>) -> Vec<Vec<i32>> {
        let mut res = vec![];
        let mut queue = std::collections::VecDeque::new();


        if let Some(node) = root {
            queue.push_back(Some(node.clone()));

            let mut next_queue = std::collections::VecDeque::new();
            let mut cur = vec![];


            while !queue.is_empty() {


                let el = queue.pop_front().unwrap();
                if let Some(n) = el {
                    cur.push(n.borrow().val);
                    next_queue.push_back(n.borrow().left.clone());
                    next_queue.push_back(n.borrow().right.clone());
                }
                if queue.is_empty() {
                    while !next_queue.is_empty() {
                        queue.push_back(next_queue.pop_front().unwrap());
                    }
                    if !cur.is_empty() {
                        res.push(cur.clone());
                    }
                    cur = vec![];
                }

            }


        }
        res.reverse();
        res



    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::vec_to_tree;

    #[test]
    fn test_level_order_bottom() {
        let nums = vec![Some(3), Some(9), Some(20),None,None, Some(15), Some(7)];
        let root = vec_to_tree(nums);

        let res = Solution::level_order_bottom(root);
        assert_eq!(res, vec![vec![15,7],vec![9,20],vec![3]]);
    }
}