struct Solution;
use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn max_depth(root: Option<Rc<RefCell<TreeNode>>>) -> i32 {
        let mut cur = 0;
        Solution::helper(root, &mut cur)

    }

    fn helper(root: Option<Rc<RefCell<TreeNode>>>, cur: &mut i32) -> i32 {
        if let Some(node) = root {
            *cur += 1;
            let left = Solution::helper(node.borrow().left.clone(), cur);

            let right = Solution::helper(node.borrow().right.clone(), cur);
            *cur -= 1;
            return left.max(right);

        } else {
            return *cur;
        }

    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::vec_to_tree;

    #[test]
    fn test_max_depth() {
        let nums = vec![Some(3), Some(9), Some(20),None,None, Some(15), Some(7)];
        let root = vec_to_tree(nums);
        let res = Solution::max_depth(root);
        assert_eq!(res, 3);
    }


    #[test]
    fn test_max_depth1() {
        let nums = vec![Some(1),  None, Some(2)];
        let root = vec_to_tree(nums);
        let res = Solution::max_depth(root);
        assert_eq!(res, 2);
    }

}