struct Solution;

use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn min_depth(root: Option<Rc<RefCell<TreeNode>>>) -> i32 {
        match root {
            Some(node) => {
                let left = Self::min_depth(node.borrow().left.clone());
                let right = Self::min_depth(node.borrow().right.clone());

                if left == 0 || right == 0 {
                    return left.max(right) + 1
                }

                left.min(right) + 1
            },
            None => 0,
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{vec_to_tree};

    #[test]
    fn test_min_depth() {
        let nums = vec![Some(3),Some(9),Some(20),None,None,Some(15),Some(7)];
        let root = vec_to_tree(nums);
        let res = Solution::min_depth(root);
        assert_eq!(res, 2);
    }
    //
    // #[test]
    // fn test_min_depth2() {
    //     let nums = vec![Some(2),None,Some(3),None,Some(4),None,Some(5),None,Some(6)];
    //     let root = vec_to_tree(nums);
    //     let res = Solution::min_depth(root);
    //     assert_eq!(res, 5);
    // }
}