struct Solution;

use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn has_path_sum(root: Option<Rc<RefCell<TreeNode>>>, target_sum: i32) -> bool {
        root.map_or(false, |root| {
            match &*root.borrow() {
                &TreeNode {val, left: None, right: None} => val == target_sum,
                &TreeNode {val, ref left, ref right} =>
                    Self::has_path_sum(left.clone(), target_sum - val) || Self::has_path_sum(right.clone(), target_sum - val),
            }
        })
    }
    // pub fn has_path_sum(root: Option<Rc<RefCell<TreeNode>>>, target_sum: i32) -> bool {
    //     let mut target_sum = target_sum;
    //
    //     if let Some(node) = root {
    //         let value = node.borrow().val;
    //         if node.borrow().left.is_none() && node.borrow().right.is_none() {
    //             if value == target_sum {
    //                 return true;
    //             } else {
    //                 return false;
    //             }
    //
    //         }
    //         if node.borrow().left.is_some() {
    //             target_sum = target_sum - value;
    //             if Solution::helper(node.borrow().left.clone(), &mut target_sum) {
    //                 return true;
    //             }
    //             target_sum = target_sum + value;
    //         }
    //
    //         if node.borrow().right.is_some() {
    //             target_sum = target_sum - value;
    //             if Solution::helper(node.borrow().right.clone(), &mut target_sum) {
    //                 return true;
    //             }
    //         }
    //         false
    //
    //
    //     } else {
    //         false
    //
    //     }
    //
    // }
    //
    //
    // fn helper(root: Option<Rc<RefCell<TreeNode>>>, target_sum:  &mut i32) -> bool {
    //     if let Some(node) = root {
    //         *target_sum -= node.borrow().val;
    //         let left = Solution::helper(node.borrow().left.clone(), target_sum);
    //         if left { return true; }
    //         let right = Solution::helper(node.borrow().right.clone(), target_sum);
    //         if right { return true; }
    //         *target_sum += node.borrow().val;
    //         false
    //     } else {
    //         if *target_sum == 0 {
    //             return true;
    //         } else {
    //             return false;
    //         }
    //     }
    // }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{vec_to_tree};

    #[test]
    fn test_has_path_sum() {
        let target_sum = 22;
        let nums = vec![Some(5),Some(4),Some(8),Some(11),None,Some(13),Some(4),Some(7),Some(2),None,None,None,Some(1)];

        let root = vec_to_tree(nums);
        let res = Solution::has_path_sum(root, target_sum);
        assert_eq!(res, true);
    }

    #[test]
    fn test_has_path_sum2() {
        let target_sum = 5;
        let nums = vec![Some(1),Some(2),Some(3)];

        let root = vec_to_tree(nums);
        let res = Solution::has_path_sum(root, target_sum);
        assert_eq!(res, false);
    }

    #[test]
    fn test_has_path_sum3() {
        let target_sum = 1;
        let nums = vec![Some(1),Some(2)];

        let root = vec_to_tree(nums);
        let res = Solution::has_path_sum(root, target_sum);
        assert_eq!(res, false);
    }
}