struct Solution;

use std::rc::Rc;
use std::cell::RefCell;
use crate::solutions::TreeNode;

impl Solution {
    pub fn is_valid_bst(root: Option<Rc<RefCell<TreeNode>>>) -> bool {
        let res = Solution::helper(root, i32::MIN as i64 - 1, i32::MAX as i64 + 1);

        res

    }

    fn helper(root: Option<Rc<RefCell<TreeNode>>>, gt: i64, le: i64) -> bool {
        if let Some(node) = root {
            let value = node.borrow().val as i64;
            if value < le && value > gt {
                return Solution::helper(node.borrow().left.clone(), gt, value) && Solution::helper(node.borrow().right.clone(), value, le);
            }

            false

        } else {
            true
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{vec_to_tree};

    #[test]
    fn test_is_valid_bst() {
        let nums = vec![Some(2), Some(1), Some(3)];
        let root = vec_to_tree(nums);
        let res = Solution::is_valid_bst(root);
        assert_eq!(res, true);
    }

    #[test]
    fn test_is_valid_bst2() {
        let nums = vec![Some(5),Some(1),Some(4),None,None,Some(3),Some(6)];
        let root = vec_to_tree(nums);
        let res = Solution::is_valid_bst(root);
        assert_eq!(res, false);
    }
}